#!/bin/sh

# voir le fichier s5age142.mib pour les info snmp

#Ip du serveur tftp
IP_TFTP=""

#communaute snmp
RW_SNMP=""

#Repertoire contenant les MIB
MIB_DIR="/usr/share/snmp/mibs/v2500/"

#etablir la liste des BPS
LISTE_BPS=`grep bps /etc/hosts | sed "s/[0-9.]* *//"`
#LISTE_BPS="bps-d01-01"

NB_SUCCESS=0
NB_FAIL=0

NOW=`date "+%d-%b-%Y %H:%M:%S"`
echo "Debut de sauvegarde $NOW"

for BPS in $LISTE_BPS
do
	echo -e "\r\n\r\n-----------------------------------------"
	echo -e "Sauvegarde de $BPS."
# nom du fichier
        VALUE=`snmpget -M $MIB_DIR -m all -Pe -Ov $BPS $RW_SNMP s5AgMyIfCfgFname.1 2>/dev/null | sed "s/(.*//"`
        if [ "$VALUE" != "$BPS" ]
        then
                echo -en "\t"
		snmpset -m all -M $MIB_DIR -Ov $BPS $RW_SNMP s5AgMyIfCfgFname.1 = "$BPS" 2>/dev/null
        fi

#ip du serveur tftp
        VALUE=`snmpget -M $MIB_DIR -m all -Pe -Ov $BPS $RW_SNMP s5AgMyIfLdSvrAddr.1 2>/dev/null | sed "s/(.*//"`
        if [ "$VALUE" != "$IP_TFTP" ]
        then
                echo -en "\t"
		snmpset -m all -M $MIB_DIR -Ov $BPS $RW_SNMP s5AgMyIfLdSvrAddr.1 = "$IP_TFTP" 2>/dev/null
	fi

# configurer pour l'upload de config sur le serveur
	VALUE=`snmpget -M $MIB_DIR -m all -Pe -Ov $BPS $RW_SNMP s5AgInfoFileAction.0 2>/dev/null | sed "s/(.*//"`
	if [ "$VALUE" != "upldConfig" ]
	then
        	echo -en "\t"
		snmpset -m all -M $MIB_DIR -Ov $BPS $RW_SNMP s5AgInfoFileAction.0 i 4 2>/dev/null
	fi

# lancer l'upload de la config sur le serveur
        echo -en "\t"
	snmpset -m all -M $MIB_DIR -Ov $BPS $RW_SNMP s5AgentGbl.24.0 i 4 2>/dev/null

#status (1=other 2=inProgress 3=success 4=fail)

	echo -n "Status : "
	STATUS=`snmpwalk -M $MIB_DIR -m all -Pe -Ov $BPS $RW_SNMP s5AgInfoFileStatus 2>/dev/null | sed "s/(.*//"`

	while [ "$STATUS" == "inProgress" ] 
	do
		STATUS=`snmpwalk -M $MIB_DIR -m all -Pe -Ov $BPS $RW_SNMP s5AgInfoFileStatus 2>/dev/null | sed "s/(.*//"`
		echo -n "#"
	done
	
	if [ "$STATUS" = "success" ]
	then
		NB_SUCCESS=`expr $NB_SUCCESS + 1`
	else
		NB_FAIL=`expr $NB_FAIL + 1`
	fi
	echo " $STATUS"
done

TOTAL=`expr $NB_FAIL + $NB_SUCCESS`
NOW=`date "+%d-%b-%Y %H:%M:%S"`
echo "Fin de sauvegarde $NOW. $NB_SUCCESS/$TOTAL OK, $NB_FAIL/$TOTAL erreurs)"

